# Citation or Reference field module

### Background

The citeref field module supports the citation types as follows:
- Digital Object Identifiers([DOI](https://www.doi.org/factsheets/DOIKeyFacts.html)) provides an actionable, interoperable, persistent link.
It utilizes the [Handle System](https://www.doi.org/factsheets/DOIHandle.html) which provides a general-purpose global name service enabling
secure name resolution over the Internet. DOIs are ubiquitously used by publishers.
<br>Crossref, DataCite and mEDRA support formatted citations via the [text/bibliography content type](https://citation.crosscite.org/docs.html#sec-4).
- The [Handle.Net](https://www.handle.net/proxy_servlet.html) Registry (HNR) allots prefixes to users of the Handle System,
for example, the form "20.500" followed by four or more digits (i.e., 20.500.1234).
- Archival Resource Keys ([ARKs](https://arks.org/)) serve as persistent identifiers, or stable, trusted references for information objects.
[N2T](https://n2t.net/) is a global ARK resolver. It keeps identifiers persistent, forwarding them to the best known web addresses.
- As a URN (Uniform Resource Name), an [ISSN (International Standard Serial Number)](https://www.issn.org/understanding-the-issn/what-is-an-issn/) identifies all continuing resources, irrespective of their medium.
The ISSN International Center provides such a resolver for «URN:ISSN » (https://urn.issn.org). For example, the syntax, https://urn.issn.org/urn:issn:xxxx-xxxx, is used to retrieve the metadata corresponding to an ISSN through this resolver.
- As a URN (Uniform Resource Name), the International Standard Book Number ([ISBN](https://en.wikipedia.org/wiki/ISBN)) is a numeric commercial book identifier that is intended to be unique.
The new [Google Books API v1](https://developers.google.com/books/docs/v1/using) provides programmatic access to many of the operations available on Google Books website.

### About
Citeref (Citation or Reference) field module provides fields that store information associated with reference/citation records found
at DOI/Handle/ARK registries or specified via URL/URN/Other methods.
The field can be used either for reference or citation purposes for a content type such as publication or application.

### Key capabilities
- Provides a form field formatter with an ability to format the citation or validate the citation identifier after the user enters the citation identifier.
In case of DOI, The module uses DOI content negotiation service to fetch the formatted citation.
- Provides a display and form field formatters to customize display of Citeref fields, including the citation identifier.
- In cased of DOI, a "style" can be chosen from the list of style names found in the [CSL style repository](https://github.com/citation-style-language/styles).
It provides a hook to fetch style names based on search and select it.

### Fields
- Citation type: Stores the citation type such as DOI, Handle, ARK, URL, URN, or other.
- Citation style name: Autocomplete style names and store the style name.
- Citation identifier: Stores the citation identifier.
- Citation text: Stores the formatted citation or customized citation.

### Uninstall validation
This is implemented using a drupal form where custom script is executed to delete the dependent fields from the system.
Currently, "node" and "storage" types are handled for the deletion.
